using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace novaterm
{
	public partial class Form1 : Form
	{
		public Form1()
		{
			InitializeComponent();

			terminalEmulator1.SetInputDelegate(InputHandler);
			terminalEmulator1.SetResizeEvent(ResizeHandler);
		}

		private void InputHandler(String text)
		{
			if (c != null)
				c.SendData(text);
		}

		private void ResizeHandler(int cols, int rows)
		{
			if (c != null) {
				c.SetWindowSize(cols, rows);
			}
		}

		void ReadCallback(byte[] data, int offset, int length, novacom.stream_type type)
		{
			terminalEmulator1.Write(data, offset, length);
		}

		private void connectButton_Click(object sender, EventArgs e)
		{
			nc = new novacom();
			nc.ServerAddress = textServerAddress.Text;

			novacom.Device[] devices = nc.GetDeviceList();
			if (devices == null) {
				terminalEmulator1.Write("failed to connect to novacomd\r\n");
				return;
			}
			
			c = nc.Connect(devices[0]);

			c.SendCommand("open tty://");
			int res = c.GetCommandResponse();
			if (res < 0) {
				terminalEmulator1.Write("error with open tty command\r\n");
				return;
			}

			textStatus.Text = "Port " + Convert.ToString(devices[0].port) + " NDUID " + devices[0].nduid;

			c.StartAsyncConnection(ReadCallback);

			c.SetWindowSize(terminalEmulator1.Columns, terminalEmulator1.Rows);

			connectButton.Enabled = false;
			textServerAddress.Enabled = false;
			terminalEmulator1.Focus();
		}

		private novacom nc;
		private novacom.Connection c;
	}
}